package com.spicysoft.sample.dribble;

import java.util.LinkedList;
import java.util.Queue;

import android.graphics.Canvas;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

/**
 * Q[IuWFNg̏A^b`̏Aʂ̕\̃Q[̊{sNX
 */
final class Main
{
  /** FPS 1b̃t[BQ[̏P */
  public static final int FRAMES_PER_SECOND = 50;
  /** t[̃~b */
  public static final int MILLIS_PER_FRAME = 1000 / FRAMES_PER_SECOND;
  /** ^CgʗpV[ */
  public static final Scene TITLE = new TitleScene();
  /** Q[vCʗpV[ */
  public static final Scene PLAY = new PlayScene();
  /** Q[I[o[ʗpV[ */
  public static final Scene OVER = new OverScene();

  /** Xbh */
  private static Thread thread;
  /** V[ */
  private static Scene current;
  /** CxgL[ */
  private static final Queue<MotionEvent> events = new LinkedList<MotionEvent>();
  /** ڂ̏H */
  private static boolean first = true;
  /** r[ */
  private static SurfaceView view;

  /**
   * Q[[vXbh𐶐 Q[[vJn or ĊJ
   */
  public static void createThread(final SurfaceView view) {
    Main.view = view;
    if (first) {
      Sounds.init(view.getContext());
      PlayLog.init(view.getContext());
      Main.initScenes(view);
      startScene(Main.TITLE);
      first = false;
    }
    thread = new Thread() {
      @Override public void run() {
        Main.runLoop();
      }
    };
    thread.start();
  }

  /**
   * Q[[vXbh𒆒f
   */
  public static void interruptThread() {
    thread.interrupt();
    Sounds.term();
  }

  /**
   * Q[[v̂Pt[̏
   */
  public static void runLoop() {
    Log.d("Dribble", "Loop in thread will start.");
    for (;;) {
      if (thread.isInterrupted()) {
        Log.d("Dribble", "Thread is interrupted");
        break;
      }
      final long start = System.currentTimeMillis();
      final Scene scene = current;
      scene.process(view);

      // (1) _uobt@OJn
      final SurfaceHolder holder = view.getHolder();
      final Canvas canvas = holder.lockCanvas();
      if (canvas != null) {
        try {
          scene.draw(canvas);
        } finally {
          // (3) _uobt@O
          holder.unlockCanvasAndPost(canvas);
        }
      }

      final long elapsed = System.currentTimeMillis() - start;
      final long towait = MILLIS_PER_FRAME - elapsed;
      if (0 < towait) {
        try {
          Thread.sleep(towait);
        } catch (final InterruptedException e) {
          Log.d("Dribble", "On calling Thread.sleep", e);
          break;
        }
      }
    }

    Log.d("Dribble", "Loop in thread exits");
    thread = null;
  }

  /**
   * SẴV[
   */
  public static void initScenes(final SurfaceView view) {
    TITLE.init(view);
    PLAY.init(view);
    OVER.init(view);
  }

  /**
   * V[ύX
   */
  public static void startScene(final Scene scene) {
    Log.d("Dribble", "startScene: scene = " + scene);
    current = scene;
    events.clear();
    current.start(view);
  }

  /** L[Cxg1擾 */
  public static synchronized MotionEvent event() {
    return events.poll();
  }

  /** L[ɃCxgi[ */
  public static synchronized void queue(final MotionEvent event) {
    events.add(event);
  }

}