package com.spicysoft.sample.dribble;

import java.text.SimpleDateFormat;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.MotionEvent;
import android.view.SurfaceView;

/**
 * ^Cg
 */
final class TitleScene implements Scene
{
  /** t𕶎񉻂鎞̏ */
  private static final SimpleDateFormat format = new SimpleDateFormat("yyNMd");
  /** 1bœ_ł */
  private static final long BLINK_DURATION = 2000;
  
  /** _ŃAj[V̊Jn */
  private long blinkStarted;
  /** wi̕` */
  private static Paint backgroundPaint;
  /** ^Cg̕` */
  private Paint titlePaint;
  /** bZ[W̕` */
  private Paint msgPaint;

  /**  */
  public void init(SurfaceView view) {
    backgroundPaint = new Paint();
    backgroundPaint.setColor(Color.BLACK);

    titlePaint = new Paint();
    titlePaint.setTextSize(48);
    titlePaint.setAntiAlias(true);
    titlePaint.setColor(Color.WHITE);
    titlePaint.setTextAlign(Paint.Align.CENTER);

    msgPaint = new Paint();
    msgPaint.setTextSize(24);
    msgPaint.setAntiAlias(true);
    msgPaint.setColor(Color.WHITE);
    msgPaint.setTextAlign(Paint.Align.CENTER);
  }

  /** \Jn */
  public void start(SurfaceView view) {
    blinkStarted = System.currentTimeMillis();
    Sounds.playBgmTitle();
  }

  /** 
   * et[̓̓CxgIuWFNg̈ړ┻菈
   */
  public void process(SurfaceView view) {
    final MotionEvent e = Main.event();
    if (e != null && e.getAction() == MotionEvent.ACTION_UP) {
      Sounds.playTouch();
      Main.startScene(Main.PLAY);
    }
  }

  /** 
   * et[̕`揈
   */
  public void draw(Canvas canvas) {
    final int w = canvas.getWidth();
    final int h = canvas.getHeight();

    canvas.drawRect(0, 0, w, h, backgroundPaint);

    canvas.drawText("Dribble! 2", w / 2, h / 2, titlePaint);

    final long elapsed = (System.currentTimeMillis() - blinkStarted)
        % BLINK_DURATION;
    final int g;
    if (elapsed <= BLINK_DURATION / 2) {
      g = (int) (255 * elapsed / (BLINK_DURATION / 2));
    } else {
      g = (int) (255 * (BLINK_DURATION - elapsed) / (BLINK_DURATION / 2));
    }
    msgPaint.setColor(Color.rgb(g, g, g));
    canvas.drawText("Touch to Start!", w / 2, h / 2 + 48, msgPaint);
    canvas.drawText("xXgXRA " + PlayLog.bestScore() + " " + format.format(PlayLog.bestPlayedAt()), w / 2, h / 2 + 96, msgPaint);
  }

}
